precision highp float;

varying vec2 st;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
// TODO: This is not used
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2; // lookup texture
uniform lowp float opacity;


mat4 contrastMatrix( float contrast )
{
    float t = ( 1.0 - contrast ) / 2.0;

    return mat4( contrast, 0.0, 0.0, 0.0,
                 0.0, contrast, 0.0, 0.0,
                 0.0, 0, contrast, 0.0,
                 t, t, t, 1.0 );
}


void main() {
    vec4 origin = texture2D(inputImageTexture, textureCoordinate);

    vec3 textureColor = origin.rgb * 15. / 16. + vec3(1. / 32.);

    float blueColor = textureColor.b * 63.0;
    vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);
    vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);
    vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);
    vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);
    vec4 newColor1 = texture2D(inputImageTexture2, texPos1);
    vec4 newColor2 = texture2D(inputImageTexture2, texPos2);
    vec4 newColor = mix(newColor1, newColor2, fract(blueColor));

    newColor = contrastMatrix(16. / 15.) * newColor;

    gl_FragColor = mix(origin, vec4(newColor.rgb, origin.w), opacity);
//    gl_FragColor = vec4(texPos1.y);
}