precision highp float;

varying vec2 st;
uniform sampler2D inputImageTexture;
uniform vec2 size;

uniform float sigma;

void main() {
    float dx = 1. / size.x;
    float w = 0.;
    vec4 color = vec4(0.);
    for (int i = - int(sigma * 3.); i <= int(sigma * 3.); i++){
        float w2 = exp(- pow (float(i), 2.) / (2. * pow(sigma, 2.)));
        color += texture2D(inputImageTexture, st + vec2(dx * float(i), 0.)) * w2;
        w += w2;
    }
    vec4 c1 = texture2D(inputImageTexture, st);
    gl_FragColor =  vec4(c1.r, c1.g, color.b / w, c1.a);
}
