precision highp float;

varying vec2 st;

uniform sampler2D inputImageTexture;

uniform vec2 size;
//uniform float intensity;

float rand(vec2 n) {
    return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float noise(vec2 p){
    vec2 ip = floor(p);
    vec2 u = fract(p);
    u = u*u*(3.0-2.0*u);

    float res = mix(
    mix(rand(ip), rand(ip+vec2(1.0, 0.0)), u.x),
    mix(rand(ip+vec2(0.0, 1.0)), rand(ip+vec2(1.0, 1.0)), u.x), u.y);
    return res*res;
}

const mat2 mtx = mat2(0.80, 0.60, -0.60, 0.80);

float fbm(vec2 p)
{
    float f = 0.0;

    f += 0.500000*noise(p + 100.); p = mtx*p*2.02;
    f += 0.031250*noise(p); p = mtx*p*2.01;
    f += 0.250000*noise(p); p = mtx*p*2.03;
    f += 0.125000*noise(p); p = mtx*p*2.01;
    f += 0.062500*noise(p); p = mtx*p*2.04;
    f += 0.015625*noise(p + sin(100.));

    return f/0.96875;
}

float pattern(vec2 p)
{
    return fbm(p + fbm(p + fbm(p)));
}

void main() {

    vec2 uv = st * 2.0 - 1.0;

    //    if(size.x > size.y){
    //        uv.x *= size.x / size.y;
    //    }else{
    //        uv.y *= size.y / size.x;
    //    }

//    float d = length(uv);
//

//    float theta = atan(uv.y, uv.x);

    float deltaX = (pattern(uv + 2.0) * 2.0 - 1.0) / 4.0;

    float deltaY = (pattern(uv + 2.0) * 2.0 - 1.0) / 4.0;

    uv.x += deltaX * cos(st.y);

    uv.y += deltaY;

    vec4 col = texture2D(inputImageTexture, (uv + 1.0) / 2.0);

    vec3 grad = normalize(vec3(deltaX, deltaY, 0.25));
    //
    vec3 light = normalize(vec3(.5, .5, .6));
    //
    float diffuse = dot(grad, light);
    //
    float spec = pow(max(0., -reflect(light, grad).z), 8.);
    //
//    gl_FragColor = mix(col, vec4(.7, .8, 1., 1.), .1) * max(diffuse, 0.0) + spec;
//
    gl_FragColor = col;
}