precision highp float;

/*
    By Shark Chili
*/

#define TWO_PI 6.28318530718
#define Y 0.1

varying vec2 st;
uniform sampler2D inputImageTexture;
uniform sampler2D maskImageTexture;
uniform vec2 size;
uniform float opacity;
//uniform float radius;
//uniform float stride;


void main() {
    vec3 result = vec3(0.);
    vec4 color0 = texture2D(inputImageTexture, st);
    vec4 color = vec4(0.);
    vec3 weight = vec3(0.);
    vec3 weight_sum = vec3(0.);

    float face_area = texture2D(maskImageTexture, st).a;

    if(face_area > 0.01){
        float radius = max(size.x, size.y) * 0.04;
        for (float r = 2.; r <= radius; r *= 2.0){
            for (float theta = 0.; theta < TWO_PI; theta += TWO_PI / 8.){
                color = texture2D(inputImageTexture, st + r * vec2(cos(theta), sin(theta)) / size);
                weight = exp(-pow(vec3(color.g - color0.g), vec3(2.)) / (0.0002 * radius)) * exp(- r / radius);
                weight_sum += weight;
                result += weight * color.rgb;
            }
        }
        result = result / weight_sum;
        gl_FragColor = mix(color0, vec4(result, color0.a), face_area * opacity);
    }else{
        gl_FragColor = color0;
    }
}